local AssignSoldier = ...

AssignSoldier:registerEnumValue ("BUILDING_PART_TYPE", "EXTENSION")

-- Register Swordman job
AssignSoldier:register({
	DataType = "JOB",
	Id = _assignSoldierPrefix .. "_SWORDMAN_OUTLAW",
	JobName = _assignSoldierPrefix .. "_SWORDMAN_OUTLAW_NAME",
	JobDescription = _assignSoldierPrefix .. "_SWORDMAN_OUTLAW_DESC",
        CharacterSetup = {
            RightHandObject = { Model = "PREFAB_TOOL_GUARD_SWORD" },
            WalkAnimation="WALK_SWORD",
            IdleAnimation="SWORD_ATTACK_01"
        },
	IsLockedByDefault = false,
	UseWorkplaceBehavior = false,
        DefaultBehavior = _assignSoldierPrefix .. "_BEHAVIOR_TREE_FIGHT",
        ProductionDelay = 30.0,
        AssetJobProgression = "DEFAULT_JOB_PROGRESSION"
})
-- Register Spearman job
AssignSoldier:register({
	DataType = "JOB",
	Id = _assignSoldierPrefix .. "_SPEARMAN_OUTLAW",
	JobName = _assignSoldierPrefix .. "_SPEARMAN_OUTLAW_NAME",
	JobDescription = _assignSoldierPrefix .. "_SPEARMAN_OUTLAW_DESC",
        CharacterSetup = {
            RightHandObject = { Model = "PREFAB_TOOL_GUARD_SPEAR" },
            WalkAnimation="WALK_SPEAR",
            IdleAnimation="SPEAR_ATTACK"
        },
	IsLockedByDefault = false,
	UseWorkplaceBehavior = false,
        DefaultBehavior = _assignSoldierPrefix .. "_BEHAVIOR_TREE_FIGHT",
        ProductionDelay = 30.0,
        AssetJobProgression = "DEFAULT_JOB_PROGRESSION"
})
-- Register Pikeman job
AssignSoldier:register({
	DataType = "JOB",
	Id = _assignSoldierPrefix .. "_PIKEMAN_OUTLAW",
	JobName = _assignSoldierPrefix .. "_PIKEMAN_OUTLAW_NAME",
	JobDescription = _assignSoldierPrefix .. "_PIKEMAN_OUTLAW_DESC",
        CharacterSetup = {
            RightHandObject = { Model = "PREFAB_TOOL_GUARD_PIKE" },
            WalkAnimation="WALK_SPEAR",
            IdleAnimation="SPEAR_ATTACK"
        },
	IsLockedByDefault = false,
	UseWorkplaceBehavior = false,
        DefaultBehavior = _assignSoldierPrefix .. "_BEHAVIOR_TREE_FIGHT",
        ProductionDelay = 30.0,
        AssetJobProgression = "DEFAULT_JOB_PROGRESSION"
})
-- Register Handman job
AssignSoldier:register({
	DataType = "JOB",
	Id = _assignSoldierPrefix .. "_HANDMAN_OUTLAW",
	JobName = _assignSoldierPrefix .. "_HANDMAN_OUTLAW_NAME",
	JobDescription = _assignSoldierPrefix .. "_HANDMAN_OUTLAW_DESC",
        CharacterSetup = {
            WalkAnimation="WALKING",
            IdleAnimation="HAND_ATTACK"
        },
	IsLockedByDefault = false,
	UseWorkplaceBehavior = false,
        DefaultBehavior = _assignSoldierPrefix .. "_BEHAVIOR_TREE_FIGHT",
        ProductionDelay = 30.0,
        AssetJobProgression = "DEFAULT_JOB_PROGRESSION"
})
function registerCompatibleJob(_job)
    AssignSoldier:override({
        Id = "NEWCOMER",
        CompatibleJobList = {
            Action = "APPEND",
            _job
        } 
    })
    AssignSoldier:override({
        Id = "SERF",
        CompatibleJobList = {
            Action = "APPEND",
            _job
        } 
    })
    AssignSoldier:override({
        Id = "COMMONER",
        CompatibleJobList = {
            Action = "APPEND",
            _job
        } 
    })
    AssignSoldier:override({
        Id = "CITIZEN",
        CompatibleJobList = {
            Action = "APPEND",
            _job
        } 
    })
end
registerCompatibleJob(_assignSoldierPrefix .. "_SWORDMAN_OUTLAW")
registerCompatibleJob(_assignSoldierPrefix .. "_SPEARMAN_OUTLAW")
registerCompatibleJob(_assignSoldierPrefix .. "_PIKEMAN_OUTLAW")
registerCompatibleJob(_assignSoldierPrefix .. "_HANDMAN_OUTLAW")

AssignSoldier:register({
        DataType = "BUILDING_FUNCTION_TRAINING_GROUND",
        Id = _assignSoldierPrefix .. "_BUILDING_FUNCTION_SWORDMAN",
        Name = _assignSoldierPrefix .. "_BUILDING_FUNCTION_SWORDMAN_NAME",
        WorkerCapacity = 1,
        RelatedJob = { 
            Job = "SOLDIER", 
            Behavior = _assignSoldierPrefix .. "_BEHAVIOR_TREE_FIGHT"
        },
        TrainingBehaviorList = { _assignSoldierPrefix .. "_BEHAVIOR_TREE_FIGHT", "BEHAVIOR_SOLDIER_TRAINING" },
        VillagerProfile = "PROFILE_SOLDIER"
})
AssignSoldier:register({
        DataType = "BUILDING_FUNCTION_TRAINING_GROUND",
        Id = _assignSoldierPrefix .. "_BUILDING_FUNCTION_TOURNAMENT",
        Name = _assignSoldierPrefix .. "_BUILDING_FUNCTION_TOURNAMENT_NAME",
        WorkerCapacity = 1,
        RelatedJob = { Job = "SOLDIER", Behavior = _assignSoldierPrefix .. "_BEHAVIOR_TREE_TOURNAMENT" },
        TrainingBehaviorList = { _assignSoldierPrefix .. "_BEHAVIOR_TREE_TOURNAMENT" , "BEHAVIOR_SOLDIER_TRAINING" },
        VillagerProfile = "PROFILE_SOLDIER"
})
function registerEnnemyFunction(_ennemy)
    AssignSoldier:register({
        DataType = "BUILDING_FUNCTION_WORKPLACE",
        Id = _assignSoldierPrefix .. "_BUILDING_FUNCTION_" .. _ennemy .. "_OUTLAW",
        Name = _assignSoldierPrefix .. "_BUILDING_FUNCTION_" .. _ennemy .. "_OUTLAW_NAME",
        WorkerCapacity = 1,
        RelatedJob = { 
            Job = _assignSoldierPrefix .. "_" .. _ennemy .. "_OUTLAW", 
            Behavior = _assignSoldierPrefix .. "_BEHAVIOR_TREE_FIGHT"
        }--,
--        TrainingBehaviorList = { _assignSoldierPrefix .. "_BEHAVIOR_TREE_FIGHT", "BEHAVIOR_SOLDIER_TRAINING" },
--        VillagerProfile = "PROFILE_SOLDIER"
    })
end
registerEnnemyFunction("SWORDMAN")
registerEnnemyFunction("SPEARMAN")
registerEnnemyFunction("PIKEMAN")
registerEnnemyFunction("HANDMAN")

-- Function list
AssignSoldier:register({
		DataType = "BUILDING_FUNCTION_ASSIGNABLE",
                Id = _assignSoldierPrefix .. "_ASSIGNABLE_FUNCTION_FIGHT",
                AuthorizedFunctionList = _assignSoldierPrefix .. "_FUNCTION_LIST_FIGHT"
})

AssignSoldier:register({
		DataType = "BUILDING_FUNCTION_LIST",
                Id = _assignSoldierPrefix .. "_FUNCTION_LIST_FIGHT",
                AssetFunctionList = {
                        _assignSoldierPrefix .. "_BUILDING_FUNCTION_SWORDMAN", --soldier
                        _assignSoldierPrefix .. "_BUILDING_FUNCTION_SWORDMAN_OUTLAW",
                        _assignSoldierPrefix .. "_BUILDING_FUNCTION_SPEARMAN_OUTLAW",
                        _assignSoldierPrefix .. "_BUILDING_FUNCTION_PIKEMAN_OUTLAW",
                        _assignSoldierPrefix .. "_BUILDING_FUNCTION_HANDMAN_OUTLAW"
                }
})

AssignSoldier:register({
        DataType = "BUILDING_FUNCTION_TRAINING_GROUND",
        Id = _assignSoldierPrefix .. "_FUNCTION",
        Name = _assignSoldierPrefix .. "_FUNCTION_NAME",
        WorkerCapacity = 1,
        RelatedJob = { Job = "SOLDIER", Behavior = _assignSoldierPrefix .. "_BEHAVIOR_TREE" },
        TrainingBehaviorList = { _assignSoldierPrefix .. "_BEHAVIOR_TREE" , "BEHAVIOR_SOLDIER_TRAINING" },
        VillagerProfile = "PROFILE_SOLDIER"
})

-- Function list
AssignSoldier:register({
		DataType = "BUILDING_FUNCTION_ASSIGNABLE",
                Id = _assignSoldierPrefix .. "_ASSIGNABLE_FUNCTION",
                AuthorizedFunctionList = _assignSoldierPrefix .. "_FUNCTION_LIST"
})

AssignSoldier:register({
		DataType = "BUILDING_FUNCTION_LIST",
                Id = _assignSoldierPrefix .. "_FUNCTION_LIST",
                AssetFunctionList = {
                        _assignSoldierPrefix .. "_FUNCTION"
                }
})

if _flagSecurity then
    AssignSoldier:register({
        DataType = "BUILDING_FUNCTION_WORKPLACE",
        Id = _assignSoldierPrefix .. "_BUILDING_FUNCTION_SECURITY_GUARD_TOWER2",
        Name = "BUILDING_FUNCTION_SECURITY_GUARD_TOWER2_NAME",
        WorkerCapacity = 1,
        RelatedJob = { 
            Job = "JOB_SECURITY_GUARD_TOWER", 
            Behavior = _assignSoldierPrefix .. "_BEHAVIOR_TREE"
        },
        InputInventoryCapacity = {
	    },
        ResourceListNeeded = {
	    },
	ResourceProduced = {
            { Resource = "RESOURCE_REPORT", Quantity = 2 },
        }
    })
    AssignSoldier:override({
		DataType = "BUILDING_FUNCTION_LIST",
                Id = _assignSoldierPrefix .. "_FUNCTION_LIST",
                AssetFunctionList = {
                        Action = "APPEND",
                        _assignSoldierPrefix .. "_BUILDING_FUNCTION_SECURITY_GUARD_TOWER2"
                }
    })
end
if _flagSecurity2 then
    AssignSoldier:register({
        DataType = "BUILDING_FUNCTION_WORKPLACE",
        Id = _assignSoldierPrefix .. "_BUILDING_FUNCTION_SECURITY_GUARD2",
	Name = "BUILDING_FUNCTION_SECURITY_GUARD_NAME",
        WorkerCapacity = 1,
        RelatedJob = { 
            Job = "JOB_SECURITY_GUARD", 
            Behavior = _assignSoldierPrefix .. "_BEHAVIOR_TREE"
	},
	InputInventoryCapacity = {
	},
        ResourceListNeeded = {
	},
	ResourceProduced = {
		{ Resource = "RESOURCE_SECURITY", Quantity = 0 },
	}
    })
    AssignSoldier:override({
		DataType = "BUILDING_FUNCTION_LIST",
                Id = _assignSoldierPrefix .. "_FUNCTION_LIST",
                AssetFunctionList = {
                        Action = "APPEND",
                       _assignSoldierPrefix .. "_BUILDING_FUNCTION_SECURITY_GUARD2"
                }
    })
end

-- Apply building asset processor
AssignSoldier:registerAssetProcessor("models/keepTrap.fbx", {
    DataType = "BUILDING_ASSET_PROCESSOR"
})
AssignSoldier:registerAssetProcessor("models/smallGate.fbx", {
    DataType = "BUILDING_ASSET_PROCESSOR"
})
AssignSoldier:registerAssetProcessor("models/octogonalTower.fbx", {
    DataType = "BUILDING_ASSET_PROCESSOR"
})
AssignSoldier:registerAssetProcessor("models/simpleGuardPost.fbx", {
    DataType = "BUILDING_ASSET_PROCESSOR"
})

AssignSoldier:registerAssetId("models/octogonalTower.fbx/Materials/redRoof", _assignSoldierPrefix .. "_OTOWER_RED_TILE_ROOF_MATERIAL")
AssignSoldier:registerAssetId("models/octogonalTower.fbx/Materials/murChateau", _assignSoldierPrefix .. "_OTOWER_STONE_MANOR_WALL_MATERIAL")

function registerAEnd(_nameFbxFile, _nameFbx, _nameAsset, _workplaceCustom, _isVisibleWhenBuilt)
    -- Register Main prefab nodes
    AssignSoldier:registerAssetId("models/" .. _nameFbxFile .. ".fbx/Prefab/" .. _nameFbx .. "Part", _assignSoldierPrefix .. "_" .. _nameAsset .. "_PREFAB")

    -- Register the building part
    AssignSoldier:register({
	DataType = "BUILDING_PART",
	Id = _assignSoldierPrefix .. "_" .. _nameAsset .. "_PART",
	Name = _assignSoldierPrefix .. "_" .. _nameAsset .. "_NAME",
	Description = _assignSoldierPrefix .. "_" .. _nameAsset .. "_DESC",
	Category = "EXTENSION",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = _assignSoldierPrefix .. "_" .. _nameAsset .. "_PREFAB"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 0 }
		}
	},
        IsVisibleWhenBuilt = _isVisibleWhenBuilt,
        AssetBuildingFunction = _assignSoldierPrefix .. "_ASSIGNABLE_FUNCTION"
    })
    AssignSoldier:registerPrefabComponent("models/" .. _nameFbxFile .. ".fbx/Prefab/" .. _nameFbx .. "Part", {
        DataType = "ASSIGN_SOLDIER_PATH_AEND_COMP",
        Enabled = true,
        WorkplaceCustom = _workplaceCustom
    })
end

registerAEnd("keepTrap", "access/keepTrapAccess", "KEEP_TRAP_ACCESS", "KeepTrapAccess", false)
registerAEnd("smallGate", "access/smallGateAccessR", "SMALL_GATE_ACCESS_R", "KeepTrapAccess", false)
registerAEnd("smallGate", "access/smallGateAccessL", "SMALL_GATE_ACCESS_L", "KeepTrapAccess", false)
registerAEnd("octogonalTower", "access/octogonalAccess", "OCTOGONAL_TOWER_ACCESS", "OctogonalAccess", false)
    AssignSoldier:registerPrefabComponent("models/keepTrap.fbx/Prefab/access/keepTrapAccessPart", {
        DataType = "COMP_BUILDING_PART",
        BuildingPartType = _optionAccessNodeType
    })
    for i=0, 3 do
        AssignSoldier:registerPrefabComponent("models/keepTrap.fbx/Prefab/access/keepTrapAccessPart/Attach_StoneGateAccess_askta" .. i, {
	    DataType = "COMP_BUILDING_ATTACH_NODE",
	    AttachNodeTypeList = { _optionAccessNodeType },
            AllowedAngles = {-45, 45}
        })
    end
    AssignSoldier:registerPrefabComponent("models/smallGate.fbx/Prefab/access/smallGateAccessRPart", {
        DataType = "COMP_BUILDING_PART",
        BuildingPartType = _optionAccessNodeType
    })
    for i=0, 1 do
        AssignSoldier:registerPrefabComponent("models/smallGate.fbx/Prefab/access/smallGateAccessRPart/Attach_StoneGateAccess_rampart_low_assgar" .. i, {
	    DataType = "COMP_BUILDING_ATTACH_NODE",
	    AttachNodeTypeList = { _optionAccessNodeType },
            AllowedAngles = {-45, 45}
        })
    end
    AssignSoldier:registerPrefabComponent("models/smallGate.fbx/Prefab/access/smallGateAccessLPart", {
        DataType = "COMP_BUILDING_PART",
        BuildingPartType = _optionAccessNodeType
    })
    for i=0, 1 do
        AssignSoldier:registerPrefabComponent("models/smallGate.fbx/Prefab/access/smallGateAccessLPart/Attach_StoneGateAccess_rampart_low_assgal" .. i, {
	    DataType = "COMP_BUILDING_ATTACH_NODE",
	    AttachNodeTypeList = { _optionAccessNodeType },
            AllowedAngles = {-45, 45}
        })
    end
    AssignSoldier:registerPrefabComponent("models/octogonalTower.fbx/Prefab/access/octogonalAccessPart", {
        DataType = "COMP_BUILDING_PART",
        BuildingPartType = _optionAccessNodeType
    })
    for i=0, 7 do
        AssignSoldier:registerPrefabComponent("models/octogonalTower.fbx/Prefab/access/octogonalAccessPart/Attach_StoneGateAccess_asoa" .. i, {
	    DataType = "COMP_BUILDING_ATTACH_NODE",
	    AttachNodeTypeList = { _optionAccessNodeType },
            AllowedAngles = {-45, 45}
        })
    end

function registerKeepTrapPlatform(_nameFbxFile, _nameFbx)
    AssignSoldier:configurePrefabFlagList("models/" .. _nameFbxFile .. ".fbx/Prefab/access/" .. _nameFbx .. "Part", { "PLATFORM" })

    AssignSoldier:registerPrefabComponent("models/" .. _nameFbxFile .. ".fbx/Prefab/access/" .. _nameFbx .. "Part/KEEP_TRAP_ACCESS_GUARDING_LOCATION", {
            DataType = "ASSIGN_SOLDIER_ACCESS_GUARDING_LOCATION_COMP",
            Enabled = true
    })
    AssignSoldier:registerPrefabComponent("models/" .. _nameFbxFile .. ".fbx/Prefab/access/" .. _nameFbx .. "Part/KEEP_TRAP_ACCESS_INTERMEDIATE_LOCATION_UP", {
            DataType = "ASSIGN_SOLDIER_ACCESS_INTERMEDIATE_LOCATION_UP_COMP",
            Enabled = true
    })
    AssignSoldier:registerPrefabComponent("models/" .. _nameFbxFile .. ".fbx/Prefab/access/" .. _nameFbx .. "Part/KEEP_TRAP_ACCESS_INTERMEDIATE_LOCATION_DOWN", {
            DataType = "ASSIGN_SOLDIER_ACCESS_INTERMEDIATE_LOCATION_DOWN_COMP",
            Enabled = true
    })
    AssignSoldier:registerPrefabComponent("models/" .. _nameFbxFile .. ".fbx/Prefab/access/" .. _nameFbx .. "Part/KEEP_TRAP_ACCESS_INTERMEDIATE_LOCATION_OUT", {
            DataType = "ASSIGN_SOLDIER_ACCESS_INTERMEDIATE_LOCATION_OUT_COMP",
            Enabled = true
    })
end

registerKeepTrapPlatform("keepTrap", "keepTrapAccess")
registerKeepTrapPlatform("smallGate", "smallGateAccessR")
registerKeepTrapPlatform("smallGate", "smallGateAccessL")
registerKeepTrapPlatform("octogonalTower", "octogonalAccess")

function registerSimpleGuardPost(_nameFbxFile, _nameFbx, _nameAsset, _ally, _swordJob, _spearJob, _pikeJob, _handJob)
    -- Register Main prefab nodes
    AssignSoldier:registerAssetId("models/" .. _nameFbxFile .. ".fbx/Prefab/" .. _nameFbx .. "Part", _assignSoldierPrefix .. "_" .. _nameAsset .. "_PREFAB")

    -- Register the building part
    AssignSoldier:register({
	DataType = "BUILDING_PART",
	Id = _assignSoldierPrefix .. "_" .. _nameAsset .. "_PART",
	Name = _assignSoldierPrefix .. "_" .. _nameAsset .. "_NAME",
	Description = _assignSoldierPrefix .. "_" .. _nameAsset .. "_DESC",
	Category = "EXTENSION",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = _assignSoldierPrefix .. "_" .. _nameAsset .. "_PREFAB"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 0 }
		}
	},
        IsVisibleWhenBuilt = false,
        AssetBuildingFunction = _assignSoldierPrefix .. "_ASSIGNABLE_FUNCTION_FIGHT"
    })
    AssignSoldier:registerPrefabComponent("models/" .. _nameFbxFile .. ".fbx/Prefab/" .. _nameFbx .. "Part", {
        DataType = "ASSIGN_SOLDIER_FIGHT_COMP",
        Enabled = true,
        Ally = _ally,
        SwordJob = _swordJob,
        SpearJob = _spearJob,
        PikeJob = _pikeJob,
        HandJob = _handJob,
        Tournament = _tournament
    })
end
registerSimpleGuardPost("simpleGuardPost", "access/simpleGuardPost", "SIMPLE_GUARD_POST", "SOLDIER",
                        _assignSoldierPrefix .. "_SWORDMAN_OUTLAW_NAME",
                        _assignSoldierPrefix .. "_SPEARMAN_OUTLAW_NAME",
                        _assignSoldierPrefix .. "_PIKEMAN_OUTLAW_NAME",
                        _assignSoldierPrefix .. "_HANDMAN_OUTLAW_NAME"
)

function registerTournamentPost(_nameFbxFile, _nameFbx, _nameAsset, _ally)
    -- Register Main prefab nodes
    AssignSoldier:registerAssetId("models/" .. _nameFbxFile .. ".fbx/Prefab/" .. _nameFbx .. "Part", _assignSoldierPrefix .. "_" .. _nameAsset .. "_PREFAB")

    -- Register the building part
    AssignSoldier:register({
	DataType = "BUILDING_PART",
	Id = _assignSoldierPrefix .. "_" .. _nameAsset .. "_PART",
	Name = _assignSoldierPrefix .. "_" .. _nameAsset .. "_NAME",
	Description = _assignSoldierPrefix .. "_" .. _nameAsset .. "_DESC",
	Category = "EXTENSION",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = _assignSoldierPrefix .. "_" .. _nameAsset .. "_PREFAB"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 0 }
		}
	},
        IsVisibleWhenBuilt = false,
        AssetBuildingFunction = _assignSoldierPrefix .. "_BUILDING_FUNCTION_TOURNAMENT"
    })
    AssignSoldier:registerPrefabComponent("models/" .. _nameFbxFile .. ".fbx/Prefab/" .. _nameFbx .. "Part", {
        DataType = "ASSIGN_SOLDIER_TOURNAMENT_COMP",
        Enabled = true,
        Ally = _ally
    })
end
registerTournamentPost("tournamentPost", "access/tournamentPost", "TOURNAMENT_POST", "SOLDIER")



