local assignSoldier = ...

--------------------------------------------------------------------------
local ASSIGN_SOLDIER_TOURNAMENT_COMP = {
	TypeName = "ASSIGN_SOLDIER_TOURNAMENT_COMP",
	ParentType = "COMPONENT",
	Properties = {
		{ Name = "Ally", Type = "string", Default = "Ally" }
	}
}

--------------------------------------------------------------------------
function ASSIGN_SOLDIER_TOURNAMENT_COMP:memorizeAgent(_agent)
--    assignSoldier:log("AssignSoldier: ASSIGN_SOLDIER_TOURNAMENT_COMP:memorizeAgent" .. tostring(_agent:getOwner()))
    self.soldierAssignAgent = _agent
end

--------------------------------------------------------------------------
function ASSIGN_SOLDIER_TOURNAMENT_COMP:init()
--    assignSoldier:log("AssignSoldier: ASSIGN_SOLDIER_TOURNAMENT_COMP:init")
    self.fighting = true
end

--------------------------------------------------------------------------
function ASSIGN_SOLDIER_TOURNAMENT_COMP:computeProximity(_comp, _pos1)
                    local pos2 = _comp:getOwner():getGlobalPosition()
                    local distance = (_pos1.x - pos2.x)^2 + (_pos1.z - pos2.z)^2
                    return distance
end

--------------------------------------------------------------------------
function ASSIGN_SOLDIER_TOURNAMENT_COMP:update()
    if (self.soldierAssignAgent == nil) then
        return
    end
    if (self:computeProximity(self, self.soldierAssignAgent:getOwner():getGlobalPosition()) > 1) then
        return
    end
    local JobName = self.soldierAssignAgent:getOwner():getEnabledComponent("COMP_VILLAGER"):getAssetJob().JobName
--    assignSoldier:log("ASSIGN_SOLDIER_TOURNAMENT_COMP:update() check job soldierAssignAgent " .. tostring(self.soldierAssignAgent:getOwner()) .. " " .. JobName)
    self.Proximity = false
    self:getLevel():getComponentManager("COMP_AGENT"):getAllComponent():forEach(
        function(comp)
            if self.Proximity then
                return --already found
            end
            local _villager = comp:getOwner():getEnabledComponent("COMP_VILLAGER")
            if (_villager ~= nil) and (_villager:getAssetJob() ~= nil) then
                if (_villager:getAssetJob().JobName == self.Ally) 
                   and (self:computeProximity(comp, self.soldierAssignAgent:getOwner():getGlobalPosition()) < 25) 
                   and (self:computeProximity(comp, self.soldierAssignAgent:getOwner():getGlobalPosition()) > 0.1) then
--                        assignSoldier:log("ASSIGN_SOLDIER_TOURNAMENT_COMP:update() ennemy detected " .. comp:getOwner().Name .. " " .. tostring(_villager:getAssetJob().JobName))
                        self.Target = comp:getOwner():getGlobalPosition()
                        self.Proximity = true
                        return;
                    end
            end
        end
    )
    if self.Proximity then
        self.soldierAssignAgent:getOwner():lookAt(self.Target)
        if not self.fighting then
            self.soldierAssignAgent:setAnimation("")
            self.fighting = true
        end
    else--if self.fighting then
        self.soldierAssignAgent:setAnimation("GUARD")
        self.fighting = false
    end
end

--------------------------------------------------------------------------
assignSoldier:registerClass(ASSIGN_SOLDIER_TOURNAMENT_COMP)


